$(document).ready(function() {
    var dragChooser = false,
        chooserX = 0,
        chooserY = 0,
        dragSlider = false,
        sliderY = 0,
        hue = 0,
        saturationHSB = 0,
        brightnessHSB = 100,
        saturationHSL = 0,
        lightnessHSL = 100;
    
    $('#chooserarea').on('mousedown',function(e) {
        dragChooser = true;
        var parentOffset = $('#chooser').parent().offset();
        chooserX = e.pageX - parentOffset.left - 5;
        chooserY = e.pageY - parentOffset.top - 5;
        setChooser();
        setColor();
        refreshPreview();
        getHexFromRGB();
    }).on('mouseup mouseleave', function() {
        dragChooser = false;
    }).on('mousemove', function(e) {
        if(dragChooser) {
            var parentOffset = $('#chooser').parent().offset();
            chooserX = e.pageX - parentOffset.left - 5;
            chooserY = e.pageY - parentOffset.top - 5;
            setChooser();
            setColor();
            refreshPreview();
            getHexFromRGB();
        }
    });

    $('#sliderarea').on('mousedown',function(e) {
        dragSlider = true;
        var parentOffset = $('#slider').parent().offset();
        sliderY = e.pageY - parentOffset.top;
        setSlider();
        setColor();
        refreshPreview();
        getHexFromRGB();
    }).on('mouseup mouseleave', function() {
        dragSlider = false;
    }).on('mousemove', function(e) {
        if(dragSlider) {
            var parentOffset = $('#slider').parent().offset();
            sliderY = e.pageY - parentOffset.top;
            setSlider();
            setColor();
            refreshPreview();
            getHexFromRGB();
        }
    });

    function setChooser() {
        if(chooserX < 0) { chooserX = 0; }
        if(chooserX > 300) { chooserX = 300; }
        if(chooserY < 0) { chooserY = 0; }
        if(chooserY > 300) { chooserY = 300; }
        $('#chooser').css({
            'position':'absolute',
            'top':chooserY + 'px',
            'left':chooserX + 'px'
        });
    }
    function setSlider() {
        if(sliderY < 0) { sliderY = 0; }
        if(sliderY > 300) { sliderY = 300; }
        $('#slider').css({
            'position':'absolute',
            'top':sliderY + 'px'
        });
    }
    function setColor() {
        hue = Math.round(sliderY * 1.2);
        $('#hsb .huevalue').text( hue );
        $('#hsl .huevalue').text( hue );
        $('#basecolor').css('background-color','hsl(' + hue + ',100%,50%)');
        saturationHSB = Math.round( chooserX / 3);
        $('#hsb .saturationvalue').text( saturationHSB );
        brightnessHSB = Math.round(100 - ( chooserY / 3));
        $('#hsb .brightnessvalue').text( brightnessHSB );

        lightnessHSL = Math.round(((brightnessHSB/100) * (1 - ((saturationHSB/100) / 2))) * 100);
        $('#hsl .lightnessvalue').text( lightnessHSL );
        //saturationHSL
        if (lightnessHSL == 0 || lightnessHSL == 100) {
            saturationHSL = 0;
        } else {
            if((1 - (lightnessHSL/100)) < (lightnessHSL/100)) {
                var smallerValue = (1 - (lightnessHSL/100));
            } else {
                var smallerValue = (lightnessHSL/100);
            }
        }
        saturationHSL = Math.round(((brightnessHSB/100) - (lightnessHSL/100)) / smallerValue * 100);
        $('#hsl .saturationvalue').text( saturationHSL );
    };
    function refreshPreview() {
        $('#result').css('background-color','hsl(' + hue + ',' + saturationHSL + '%,' + lightnessHSL + '%)');
    };
    function getHexFromRGB() {
        var result = $('#result').css('background-color');
        var rgb = result.replace(/^rgba?\(|\s+|\)$/g,'').split(',');
        for(var i in rgb) {
            var redValue = rgb[0];
            var greenValue = rgb[1];
            var blueValue = rgb[2];
        }
        $('#rgb .redvalue').text( redValue );
        $('#rgb .greenvalue').text( greenValue );
        $('#rgb .bluevalue').text( blueValue );

        var rgb = result;
        function rgb2hex(rgb){
            rgb = rgb.match(/^rgba?[\s+]?\([\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?,[\s+]?(\d+)[\s+]?/i);
            return (rgb && rgb.length === 4) ? '#' +
                ('0' + parseInt(rgb[1],10).toString(16)).slice(-2) +
                ('0' + parseInt(rgb[2],10).toString(16)).slice(-2) +
                ('0' + parseInt(rgb[3],10).toString(16)).slice(-2) : '';
        }
        $('#hex .hexvalue').text(rgb2hex(rgb));
    };
});